package Spring;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.LayoutManager;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.Iterator;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

public class SpringUI extends JFrame{

	private Graph graph;
	public SpringUI(){
//		this.add(arg0);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		ActionListener actionListener = new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				graph.shake();
			};
		};
		
		JPanel content=new JPanel();
		content.setLayout(new BorderLayout());
		graph=new Graph();
		JButton shake=new JButton("Shake");
		shake.addActionListener(actionListener);
		
		content.add(graph,BorderLayout.CENTER);
		content.add(shake,BorderLayout.PAGE_END);
		this.add(content);
		this.setBackground(Color.WHITE);
		this.pack();
		this.setVisible(true);
		
	}
	
	
	public void drawSpring(Spring spring) {
		graph.drawSpring(spring);
	}
	
	private class Graph extends JPanel{	
		private int fact=3;
		private Spring spring;
		public Graph() {
			spring=new Spring();
			this.setBackground(Color.LIGHT_GRAY);
			this.setPreferredSize(new Dimension(400,400));
			this.setVisible(true);
			
		}
		
		public void shake() {
			spring.shake();
		}

		public void drawSpring(Spring spring){
			this.spring=spring;
			this.repaint();
		}
		
		protected void paintComponent(Graphics g){
			Graphics2D g2d=(Graphics2D)g;
			g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			
			g.clearRect(0,0,400,400);
			g.setColor(Color.blue);
			g.drawLine(200, 0, 200, 400);
			g.drawLine(0, 200, 400, 200);
			
			if(spring!=null){
				g.setColor(Color.RED);
				Iterator<Line2D> iter1=spring.iterVertices();
				while(iter1.hasNext()){
					Line2D line=(Line2D)iter1.next();
					g2d.drawLine(200+(int)(line.getX1()*fact),200+(int)(line.getY1()*fact),200+(int)(line.getX2()*fact),200+(int)(line.getY2()*fact));
				}
				g.setColor(Color.GREEN);
				Iterator<Point2D> iter2=spring.iterPoints();
				while(iter2.hasNext()){
					Point2D point=(Point2D)iter2.next();
					g2d.fillOval(199+(int)(point.getX()*fact),199+(int)(point.getY()*fact),3,3);
				}
			}
		}	
	}
}
